# 主义主义网站 0.2 设计

## 版本历史

* `ismism-0.0` 开发**用户**身份相关功能（2022）
* `ismism-0.1` 开发俱乐部**会员**状态功能（2023）

`ismism-0.2` 版本目标（2024）

1. 设立活动**机制**
2. 开发活动**流程**相关功能
3. 确立网站**框架**，降低开发与维护门槛

## 机制

`id` - identity identify
`rec` - record recognize

* 用户 `usr`（user use `id`）
* 俱乐部 `soc` - 关系（sociation sociate `id`）
	- 贡献 `ern` - 话语关系（earned earn `rec`）
	- 积分 `cdt` - 资源关系（credit `rec`）
	- 订单 `dbt` - 消费关系（debit `rec`）
* 活动 `agd` - 流程与分工（agenda `id`）
	- 联络 `sec`
	- 门槛 `req`
	- 报名 `can`
	- 分工 `usr`
	- 分配 `rew`
	- 执行 `fin`
* 消息 `msg`
* 动态 `crn`
* 权限 `aut`

## 可见度

统计：联络员、会员、贡献、积分、记录、消息 的统计
动态：贡献、积分、消息、活动
记录：贡献记录、积分记录、订单

全部 -> 超管/管理员/技术员可见

用户
* 统计 -> 全部可见
* 动态 -> 所属俱乐部会员可见
* 记录 -> 用户及所属俱乐部联络员可见

`#{usr}`
`#{usr}-{utc}`
`#{usr}-[cdt|dbt|ern|msg|act]`
`#{usr}-[cdt|dbt|ern|msg|act]-{yyyymm}`

俱乐部
* 统计 -> 全部可见
* 置顶动态 -> 全部可见
* 动态 -> 会员可见
* 记录 -> 联络员可见

`#{soc}`
`#{agd}`
`#{soc}-[cdt|dbt|ern|agd|msg|act]`
`#{soc}-[cdt|dbt|ern|agd|msg|act]-{yyyymm}`
`#{soc}-{usr}`
`#{soc}-{usr}-[cdt|dbt|ern|agd|msg|act]`
`#{soc}-{usr}-[cdt|dbt|ern|agd|msg|act]-{yyyymm}`
`#{agd}-{usr}`
`#{agd}-{usr}-[cdt|dbt|ern|agd|msg|act]`
`#{agd}-{usr}-[cdt|dbt|ern|agd|msg|act]-{yyyymm}`

`hash = {usr?, soc?, agd?, rec?, utc?}`

`hash` -> `json`  -> `md`

## 结构

`ismism`
* `cli`
* `src`
	- `eid` 数据
	- `doc` 数据关系
		- `pas.ts` 浏览权限
		- `doc.ts` 数据文档
		- `frm.ts` 数据操作
		- `nav.ts` 浏览状态
		- `dmd.ts` render: `doc` -> `md`
		- `fmd.ts` render: `frm` -> `md`
		- `mdh.ts` render: `md` -> `htm`
* `tst`
	- `json`
	- `doc`
* `ui`
	- `bind`
		- `que.ts`
		- `pos.ts`
* `mod`

## 路径 route

* 导航 nav
  - `主义主义` -> `/`
  - `同城俱乐部` -> `#soc`
  - `劳动法律` -> `#54`
  - `卫生健康` -> `#58`
  - `理论学习` -> `#173`
  - `登陆` | `{用户名}` -> `#pas` | `#123`

* `/` 根目录
  - 所属俱乐部列表（按贡献/积分排序）【登陆可见】
  - 所属俱乐部动态（b站投稿、会员文章、新增会员、活动更新、积分统计、贡献统计）【登陆可见】
  - 所有俱乐部索引（一级行政区 -> 二级行政区 -> 俱乐部列表）【公开可见】
  - 所有俱乐部动态（b站投稿、会员统计、积分统计、贡献统计）【公开可见】

* `#123` 用户页面 【pub】
  - 牌子：【超级管理员】【管理员】【技术员】【积分】【联络员】【贡献】
  - ?警告：已被xxx俱乐部拉黑
  - `{ID} {用户名}`
  - `{adm} {utc}`
  - 用户统计：90天贡献，90天使用/过期积分
  - `{msg}`
  - 文章 + `{crn}`
  - 积分使用、积分记录、贡献记录【aut】
  - `#123?usr`【#123】 -> 编辑
  - `#123?usr&clr`【#123】 -> 登出

* `#soc` 同城俱乐部
  - 所有俱乐部索引（一级行政区 -> 二级行政区 -> 俱乐部列表）【公开可见】
  - 所有俱乐部动态（会员统计、积分统计、贡献统计）【公开可见】
  - `#soc?add` -> 添加俱乐部【aut】
  - `#soc?soc` -> 编辑俱乐部【aut】
  - `#soc?aut` -> 设置管理员【sup】
  - `#soc?tec` -> 设置技术员【aut】
  - `#soc?usr` -> 添加用户【tec】 - `?{paswrd}`

* `#s1` 俱乐部页面
  - `{ID} {用户名}`
  - `{adm} {utc}`
  - `{msg}` + `{crn}`
  - `{sec}` 联络员
  - `{agd}` 活动
  - 会员
	- `#s1?cdt` -> 会员积分统计【soc】
	- `#s1?cdt&yyyy` -> yyyy积分记录【sec】
    - `#s1?cdt&del` -> 删除积分记录【sec】
	- `#s1?cdt&add` -> 添加积分【sec】
  - 积分使用【sec】
    - `#s1?dbt` -> 近期积分使用【sec】
    - `#s1?dbt&yyyy` -> yyyy年积分使用【sec】
    - `#s1?dbt&del` -> 删除积分使用【sec】
  - 贡献记录
	- `#s1?ern&add` -> 添加贡献【sec】
	- `#s1?ern` -> 近期贡献记录【sec】
	- `#s1?ern&del` -> 删除贡献【sec】
	- `#s1?ern&yyyy` -> yyyy年贡献记录【sec】
  - `#s1?soc` -> 编辑俱乐部【aut】
  - `#s1?msg` -> 编辑简介【sec】
  - `#s1?nam=""` -> 活动【pub】
  - `#s1?agd&add` -> 添加活动【sec】
  - `#s1?agd&nam=""` -> 编辑活动【sec】

