import { Agd, Aut, Cdt, Crn, Ern, Id, Msg, Soc, Usr } from "../typ.ts"

export type Sum = { cdt: number, dbt: number, ern: number, act: number, msg: number }

export type Doc = {
	usr: Pick<Usr, keyof Id> & {
		ban: { soc: Soc["_id"], nam: Soc["nam"], utc: number },
		sum: Sum,
		aut?: Aut["aut"],
		sec?: [Soc["_id"], Soc["nam"]][],
		cdt?: [Soc["_id"], Soc["nam"], Cdt["amt"]][],
		ern?: [Soc["_id"], Soc["nam"], Ern["amt"]][],
		msg?: { msg: Msg["_id"], nam: string }[],
		crn?: Crn,
	},
	soc: Pick<Soc, keyof Id> & {
		sum: Sum,
		sec?: [Usr["_id"], Usr["nam"]][],
		cdt?: [Usr["_id"], Usr["nam"]][],
		agd?: Agd[],
		pin: { msg: Msg["_id"], nam: Msg["nam"], usr: Usr["nam"] }[],
		msg: { msg: Msg["_id"], nam: Msg["nam"], usr: Usr["nam"] }[],
		crn?: Crn[],
	},
	agd: Pick<Agd, keyof Id> & {
		soc: [Soc["_id"], nam: Soc["nam"]],
		sec: [Usr["_id"], Usr["nam"]][],
		pub: boolean,
		msg?: string,
		agd: (Agd["agd"][0] & {
			can?: Agd["agd"][0]["can"],
			usr?: Agd["agd"][0]["usr"],
		})[],
		fin: number,
	}
}
