export type Id = {
	_id: number,
	utc: number,
	nam: string,
	adm1: string,
	adm2: string,
	msg: string,
}

export type Usr = Id & {
	nbr?: string,
	pas?: { cod: number, utc: number } | { wrd: string },
	jwt?: string,
	bid?: string,
}
export type Soc = Id & {
	sec: Usr["_id"][],
	agr: { msg: string, utc: number },
	pin: { msg: Msg["_id"] }[],
}
export type Agd = Id & {
	soc: Soc["_id"],
	sec: Usr["_id"][],
	pub: boolean,
	agd: {
		nam: string,
		utc: number,
		req: { ern: number, dbt: number, aug: number },
		rew: { cdt: number, ern: number },
		can: { len: number, usr: Usr["_id"][] },
		usr: { utc: number, usr: Usr["_id"][] },
	}[],
	fin: number,
}

export type Rec = {
	_id: { usr: Usr["_id"], soc: Soc["_id"], utc: number },
	msg: string,
	amt: number,
	sec?: Usr["_id"],
}
export type Cdt = Rec & {
	utc: { eft: number, exp: number, agr: number },
	aug?: { msg: string, amt: number, usr: Usr["_id"], utc: number }[],
}
export type Dbt = Rec
export type Ern = Rec

export type Act = {
	_id: string,
	utc: number,
	exp: number,
	soc: Soc["_id"],
	sec: Usr["_id"],
	msg: string,
	act: { day: number, amt: number },
	eft?: { usr: Usr["_id"], utc: number },
}
export type Msg = {
	_id: { usr: Usr["_id"], utc: number },
	utc: number,
	nam: string,
	msg: string,
}
export type Crn = {
	_id: Usr["_id"],
	nam: string,
	crn: { msg: string, url: string, utc: number }[],
}

export type Aut = {
	_id: Usr["_id"],
	aut?: "sup" | "aut" | "tec",
	ban?: { soc: Soc["_id"], utc: number }[],
}
