import { pmd, htm } from "../../src/doc/mdh.ts"

export function section(
	h5: string,
	md: string,
): string {
	return htm([{
		tag: "section",
		htm: htm([{ tag: "h5", htm: h5 }, ...pmd(md)]),
	}])
}

export function idnam(
	h5: string,
	idnam: [number, string][],
): string {
	return section(h5, idnam.map(([id, nam]) => `[${nam}](#${id})`).join("、"))
}
